/*-
 * Copyright (c) 2003-2004, Maxime Henrion <mux@FreeBSD.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: diff.h,v 1.6 2005/05/21 20:16:40 mux Exp $
 */
#ifndef _DIFF_H_
#define _DIFF_H_

struct stream;
struct keyword;

/* Description of an RCS delta. */
struct diff {
	char *d_rcsfile;			/* RCS filename */
	char *d_cvsroot;			/* CVS root prefix */
	char *d_revnum;				/* Revision number */
	char *d_revdate;			/* Revision date */
	char *d_author;				/* Author of the delta */
	char *d_log;				/* Commit log message */
	char *d_tag;				/* CVS tag, if any */
	//intmax_t d_loglines;			/* Number of "Log" lines */
	char *d_state;				/* State of the branch */
	struct stream *d_diff;			/* The delta */
	struct stream *d_orig;			/* Original file */
	struct stream *d_to;			/* Target file */
	int d_expand;				/* CVS expansion mode */
};

int		 diff_apply(struct diff *, struct keyword *);

#endif /* !_DIFF_H_ */
